WINNING_DEBUG = false


Winning_Chat_Icon_Texture = "\124TInterface\\PvPRankBadges\\PvPRank12:15:15:0:0\124t"
-- Insert our icon into chat messages.
Winning_Chat_Icon = function(msg)
    return format("%s %s", Winning_Chat_Icon_Texture, msg)
end


-- Convenience function for sending messages to the chat window.
Winning_Chat = function(msg)
    text = format("Winning: %s", msg)
    result = Winning_Chat_Icon(text)
	DEFAULT_CHAT_FRAME:AddMessage(result)
end


-- Logging function that takes addon debug state into account.
Winning_Log = function(msg)
	if WINNING_DEBUG then
        msg = format("[%s] - %s", date("%H:%M:%S", time()), msg)
        Winning_Chat(msg)
	end
end


-- Convert seconds into a duration string: "34:01"
Winning_Duration = function(total_seconds)
    local seconds = math.floor(total_seconds % 60)
    local minutes = math.floor(total_seconds / 60)
    return format("%d:%s", minutes, tostring(seconds):rpad(2, "0"))
end


-- Pads str to length len with char from right
-- Mostly barrowed from here: http://snipplr.com/view/13092/strlpad--pad-string-to-the-left/
string.lpad = function(str, len, char)
    local s = str or "";
    if char == nil then char = ' ' end
    return s .. string.rep(char, len - #s)
end

string.rpad = function(str, len, char)
    local s = str or "";
    if char == nil then char = ' ' end
    return string.rep(char, len - #s) .. s
end


local random = math.random
Winning_UUID = function()
    local template ='xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'
    return string.gsub(template, '[xy]', function (c)
        local v = (c == 'x') and random(0, 0xf) or random(8, 0xb)
        return string.format('%x', v)
    end)
end


Winning_Humanify = function(num)
    num = tonumber(num) or 0
    local adjusted = 0
    if num > 999999999 then
        -- round billions
        return format("%.1fB", num/1000000000)
    elseif num > 999999 then
        -- round millions
        return format("%.2fM", num/1000000)
    elseif num > 999 then
        -- round thousands
        return format("%dk", math.ceil(num/1000))
    end
    return num
end
